Bug 852752 (CVE-2012-3547)

Summary: CVE-2012-3547 freeradius: stack-based buffer overflow via long expiration date fields in client X509 certificates
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: anshockm, dpal, jdennis, lnovy, pkis, prasad, security-response-team
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20120910,reported=20120829,source=distros,cvss2=5.0/AV:N/AC:L/Au:N/C:N/I:N/A:P,rhel-5/freeradius=notaffected,rhel-5/freeradius2=affected,rhel-6/freeradius=affected,fedora-all/freeradius=affected,cwe=CWE-121[auto]
Fixed In Version: freeradius 2.2.0 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-10-02 14:07:05 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 855308, 855315, 855316, 855317, 855909    
Bug Blocks: 852759    
Attachments:
Description Flags
Proposed patch to correct this from Alan DeKok from FreeRADIUS upstream none

Description Jan Lieskovsky 2012-08-29 09:43:56 EDT
A stack-based buffer overflow flaw was found in the way FreeRADIUS, a high-performance and highly configurable free RADIUS server, performed x509 certificates validation when freeradius was configured to use some of TLS-based Extensible Authentication Protocols, EAP (EAP-TLS, EAP-TTLS, or PEAP). A remote RADIUS client could present a specially-crafted X509_v3 certificate that, when processed by RADIUS server in order to establish TLS session, would lead to radiusd daemon crash or, potentially, arbitrary code execution with the privileges of the user running the radiusd service.

Upstream patch that introduced this issue:
[1] https://github.com/alandekok/freeradius-server/commit/a368a6f4f4aaf

Acknowledgements:

Red Hat would like to thank Timo Warns of PRESENSE Technologies GmbH for reporting this issue.
Comment 2 Jan Lieskovsky 2012-08-29 09:48:18 EDT
Preliminary embargo date for this issue has been set up to Monday, 10-th of September, 2012.
Comment 4 Jan Lieskovsky 2012-08-29 09:51:34 EDT
This issue did NOT affect the version of the freeradius package, as shipped with Red Hat Enterprise Linux 5 as it did not include the upstream a368a6f4f4aaf commit, which introduced the issue, yet.

--

This issue affects the version of the freeradius2 package, as shipped with
Red Hat Enterprise Linux 5.

--

This issue affects the version of the freeradius package, as shipped with
Red Hat Enterprise Linux 6.
Comment 5 Jan Lieskovsky 2012-08-29 10:07:29 EDT
Created attachment 607916 [details]
Proposed patch to correct this from Alan DeKok from FreeRADIUS upstream
Comment 17 Jan Lieskovsky 2012-09-10 11:12:47 EDT
Created freeradius tracking bugs for this issue

Affects: fedora-all [bug 855909]
Comment 23 Tomas Hoger 2012-09-24 14:52:29 EDT
(In reply to comment #5)
> Created attachment 607916 [details]
> Proposed patch to correct this from Alan DeKok from FreeRADIUS upstream

Committed upstream in:
https://github.com/alandekok/freeradius-server/commit/78e5aed56c36a9231bc91ea5f55b3edf88a9d2a4
Comment 25 errata-xmlrpc 2012-10-02 13:24:38 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2012:1327 https://rhn.redhat.com/errata/RHSA-2012-1327.html
Comment 26 errata-xmlrpc 2012-10-02 13:24:45 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2012:1326 https://rhn.redhat.com/errata/RHSA-2012-1326.html